/* GCC */

#include <cstdio>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

int main(){
    freopen ("race.in", "r", stdin);
    freopen ("race.out", "w", stdout);

    vector <vector <int> > EdgeCh, Edge;
    vector <int> Ver, MustVis, Hold;
    vector <int> Queue;
    int n, start, finish;
    char ch;

    EdgeCh.resize(1);
    while (scanf("%c", &ch) == 1){
        if (ch == 10) EdgeCh.resize(EdgeCh.size()+1); else EdgeCh[EdgeCh.size()-1].push_back(int (ch));
    }

    n = EdgeCh.size()-1;
    EdgeCh.resize(n); Edge.resize(n);

    for (int i = 0; i<n; i++){
        Edge[i].assign(1, 0);
        for (int j = 0; j<EdgeCh[i].size(); j++){
            if (EdgeCh[i][j] == 32) Edge[i].push_back(0); else Edge[i][Edge[i].size()-1] = Edge[i][Edge[i].size()-1]*10 + int(EdgeCh[i][j]) - 48;
        }
    }

    for (int i = 0; i<n; i++){
        if ((Edge[i].size() == 1) && (Edge[i][0] == 0)) Edge[i].resize(0);
        for (int j = 0; j<Edge[i].size(); j++){
            if (Edge[i][j] == 0) {
                for (int k = j; k<Edge[i].size()-1; k++) Edge[i][k] = Edge[i][k+1];
                Edge[i].resize(Edge[i].size()-1);
                j--;
            } else {
                Edge[i][j] -= 1;
            }
        }
    }

    finish = -10; start = -10;
    for (int k = 0; k<n; k++){
        bool p = true;
        for (int i = 0; i<n; i++){
            bool Floc = false;
            for (int j = 0; j<Edge[i].size(); j++){
                if (Edge[i][j] == k) p = false;
            }
        }
        if (p) start = k;
    }

    for (int k = 0; k<n; k++){
        for (int i = 0; i<n; i++){
            if (Edge[i].size() == 0) finish = i;
        }
    }

    printf("%d %d\n", start+1, finish+1);

    MustVis.assign(n, 0); Hold.assign(n, 0);

    for (int k = 0; k<n; k++){
        Queue.assign(1, start);
        Ver.assign(n, 0);
        int point = 0;

        while (point < Queue.size()){
            int now = Queue[point];
            Ver[now] = 1;
            for (int i = 0; i<Edge[now].size(); i++){
                if ((Ver[Edge[now][i]] == 0) && (Edge[now][i] != k)) Queue.push_back(Edge[now][i]);
            }
            point++;
        }

        if (Ver[finish] == 0) MustVis[k] = 1;
    }
    MustVis[finish] = 0;
    for (int i = 0; i<n; i++) Hold[i] = MustVis[i];
/*
    for (int i = 0; i<n; i++){
        printf("%d ", MustVis[i]);
    }
    printf("\n");
*/
    for (int k = 0; k<n; k++){
        Queue.assign(1, k);
        Ver.assign(n, 0);
        int point = 0;

        while (point < Queue.size()){
            int now = Queue[point];
            Ver[now] = 1;
            for (int i = 0; i<Edge[now].size(); i++){
                if (Ver[Edge[now][i]] == 0) Queue.push_back(Edge[now][i]);
                if (Edge[now][i] == k) Hold[k] = 0;
            }
            point++;
        }
    }
/*
    for (int i = 0; i<n; i++){
        printf("%d ", Hold[i]);
    }
    printf("\n");
*/
    vector <int> MustVisN, HoldN;

    for (int i = 0; i<n; i++){
        if (MustVis[i] == 1) MustVisN.push_back(i+1);
        if (Hold[i] == 1) HoldN.push_back(i+1);

    }

    printf("%d", MustVisN.size());
    for (int i = 0; i<MustVisN.size(); i++) printf(" %d", MustVisN[i]);
    printf("\n");

    printf("%d", HoldN.size());
    for (int i = 0; i<HoldN.size(); i++) printf(" %d", HoldN[i]);

    return 0;
}
