/* GCC */
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>

using namespace std;
vector< vector< int> > input(223);
vector<int> notAv, divs;
vector<bool> isFinish(223, true), isStart(223, true);
vector<bool> used;
int n, forbidden;

void makeLine(string s, int a){
    if(s.size()==0) return;
    stringstream ss(s);
    int z;
    while(!ss.eof()){
        ss>>z;
        input[a].push_back(z);
        isFinish[a]=false;
        isStart[z]=false;
    }
}

void readData(){
    freopen("race.in", "r", stdin);

    string s;
    int i=1;
    while(getline(cin, s)){
        makeLine(s, i);
        i++;
    }
    n=i-1;
    input.erase(input.begin()+i, input.end());
    fclose(stdin);
}

void dfs(int curr){
    if(used[curr]) return;
    used[curr]=true;
    for(int i=0; i<input[curr].size(); i++){
        int to=input[curr][i];
        if(used[to] || forbidden==to) continue;
        dfs(to);
    }
}

void fileOut(){
    freopen("race.out", "w", stdout);

    int start, finish;
    for(int i=1; i<=n; i++){
        if(isStart[i]) start=i;
        if(isFinish[i]) finish=i;
    }
    cout<<start<<' '<<finish<<endl;
    for(int i=1; i<=n; i++){
        if(i==start || i==finish) continue;
        forbidden=i;
        used.assign(n+1, false);
        dfs(start);
        if(!used[finish]){
            notAv.push_back(i);
            vector<bool> used2=used;
            used.assign(n+1, false);
            dfs(i);
            int u1=0, u2=0;
            for(int z=1; z<=n; z++){
                if(used[z] && used2[z]) break;
                if(used[z]) u1++;
                if(used2[z]) u2++;
            }
            if(u1>2 && u2>1)  divs.push_back(i);
        }
    }

    cout<<notAv.size();
    for(int i=0; i<notAv.size(); i++){
        cout<<' '<<notAv[i];
    }
    cout<<endl;
    cout<<divs.size();
    for(int i=0; i<divs.size(); i++){
        cout<<' '<<divs[i];
    }
    cout<<endl;

    fclose(stdout);
}

int main(){
    readData();
    fileOut();
    return 0;
}
