#include<fstream>
#include<queue>

using namespace std;

bool arr[222][222], important[222], very_important[222];
int n;
int start, finish;

bool bfs(int notuse){
    bool been[222];
    for(int i = 0; i < n; i++){
        been[i] = false;
    }
    been[start] = true;
    queue<int> q;
    q.push(start);
    while(q.size()){
        int v = q.front();
        q.pop();
        if(v == notuse) continue;
        for(int i = 0; i < n; i++){
            if(!been[i] && arr[v][i]){
                been[i] = true;
                q.push(i);
            }
        }
    }
    return been[finish];
}

bool bfs2(int notuse){
    bool been1[222];
    for(int i = 0; i < n; i++){
        been1[i] = false;
    }
    been1[start] = true;
    queue<int> q1;
    q1.push(start);
    while(q1.size()){
        int v = q1.front();
        q1.pop();
        if(v == notuse) continue;
        for(int i = 0; i < n; i++){
            if(!been1[i] && arr[v][i]){
                been1[i] = true;
                q1.push(i);
            }
        }
    }
    bool been2[222];
    for(int i = 0; i < n; i++){
        been2[i] = false;
    }
    been2[notuse] = true;
    queue<int> q2;
    q2.push(notuse);
    while(q2.size()){
        int v = q2.front();
        q2.pop();
        for(int i = 0; i < n; i++){
            if(!been2[i] && arr[v][i]){
                been2[i] = true;
                q2.push(i);
            }
        }
    }
    bool is_very_important = true;
    for(int i = 0; i < n; i++){
        if(i == notuse) continue;
        if(been1[i] && been2[i]){
            is_very_important = false;
            break;
        }
    }
    return is_very_important;
}

int main(){
    ifstream in;
    ofstream out;
    in.open("race.in");
    out.open("race.out");

    string s;
    while(getline(in, s)){
        if(s.size() == 0){
            finish = n++;
            continue;
        }
        int num = 0;
        for(int i = 0; i < s.size(); i++){
            char c = s[i];
            if(c == ' '){
                arr[n][num-1] = true;
                num = 0;
                continue;
            }
            num *= 10;
            num += int(c - '0');
        }
        arr[n][num-1] = true;
        n++;
    }
    for(int i = 0; i < n; i++){
        bool isstart = true;
        for(int j = 0; j < n; j++){
            if(arr[j][i]) isstart = false;
        }
        if(isstart) {
            start = i;
            break;
        }
    }
    out << start+1 << ' ' << finish+1 << endl;
    int num_imp = 0;
    for(int i = 0; i < n; i++){
        if(i == start || i == finish) continue;
        if(!bfs(i)){
            important[i] = true;
            num_imp++;
        }
    }
    out << num_imp;
    int num_very_imp = 0;
    for(int i = 0; i < n; i++){
        if(important[i]){
            out << ' ' << i+1;
            bool is_vi = bfs2(i);
            very_important[i] = is_vi;
            num_very_imp += is_vi;
        }
    }
    out << endl << num_very_imp;
    for(int i = 0; i < n; i++){
        if(very_important[i]){
            out << ' ' << i+1;
        }
    }
    out << endl;

    out.close();
    in.close();
}
