/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <queue>
#include <set>

using namespace std;

const int Nmax = 300;

int n = 0;
bool prep = false, can_be_last = false;

vector <bool> visited;
vector <int> adj[Nmax];
bool st[Nmax];

int word(string s, int &cur){
    int ret = 0, temp = 0;
    while(s[cur] == ' ' && cur < s.length()) cur++;
    while(s[cur] != ' ' && cur < s.length()) {
        temp = (int) s[cur];
        temp -= (int) '0';
        ret*=10;
        ret+=temp;
        cur++;
    }
    while(s[cur] == ' ' && cur < s.length()) cur++;
    return ret;
}

bool check_first(int st, int cur, int fin){
    if(cur == st || cur == fin) return false;
    int temp = 0, next = 0, v = 0;
    queue <int> Q;
    visited.assign(n+3,false);
    Q.push(st);
    while(!Q.empty()){
        v = Q.front();
        Q.pop();
        visited[v] = true;
        for(int i = 0, k = adj[v].size(); i < k; i++){
            next = adj[v][i];
            if(!visited[next] && next != cur){
                Q.push(next);
            }
        }
    }
    return (!visited[fin]);

}

bool check_second(int st, int cur, int fin){
    if(adj[st].size() == 1 && adj[st][0] == cur) return false;
    if(!can_be_last){
        for(int i = 0, k = adj[cur].size(); i < k; i++){
            if(adj[cur][i] == fin) return false;
        }
    }
    int temp = 0, next = 0, v = 0;
    queue <int> Q;
    set <int> reach;
    visited.assign(n+3,false);
    Q.push(cur);
    while(!Q.empty()){
        v = Q.front();
        Q.pop();
        reach.insert(v);
        visited[v] = true;
        for(int i = 0, k = adj[v].size(); i < k; i++){
            next = adj[v][i];
            if(!visited[next]){
                Q.push(next);
            }
        }
    }
    reach.erase(cur);
    visited.assign(n+3,false);
    Q.push(st);
    while(!Q.empty()){
        v = Q.front();
        Q.pop();
        if(reach.count(v) != 0) return false;
        visited[v] = true;
        for(int i = 0, k = adj[v].size(); i < k; i++){
            next = adj[v][i];
            if(!visited[next] && next != cur){
                Q.push(next);
            }
        }
    }
    return true;

}

int main(){
    freopen("race.in","r",stdin);
    freopen("race.out","w",stdout);
    string s;
    int cur = 0, start = 0, finish = 0, cur_num = 0, cnt_f = 0, cnt_s = 0;
    vector <int> first, second;
    for(int i = 0; i < Nmax; i++) st[i]= false;
    while(getline(cin,s)){
        n++;
        cur = 0;
        if(s.length() == 0) finish = n;
        while(cur < s.length()){
            cur_num = word(s,cur);
            st[cur_num] = true;
            adj[n].push_back(cur_num);
        }
    }
    for(int i = 1; i <= n; i++) if(!st[i]) start = i;
    for(int i = 1; i <= n; i++){
        for(int j = 0; j < adj[i].size(); j++){
            if(adj[i][j] == finish && !prep) prep = true;
            else if(adj[i][j] == finish) can_be_last = true;
        }
    }
    visited.resize(n+3,0);
    for(int i = 1; i <= n; i++){
        if(check_first(start,i,finish)){
            first.push_back(i);
            cnt_f++;
            if(check_second(start,i,finish)){
                second.push_back(i);
                cnt_s++;
            }
        }
    }
    cout << start << " " << finish << "\n";
    cout << cnt_f << " ";
    for(int i = 0, k = first.size(); i < k; i++) cout << first[i] << " ";
    cout << "\n";
    cout << cnt_s << " ";
    for(int i = 0, k = second.size(); i < k; i++) cout << second[i] << " ";
    cout << "\n";
    return 0;
}
