#include <iostream>
#include <fstream>
#include <algorithm>
#include <string>
#include <queue>
#include <cmath>
#include <vector>

using namespace std;

    vector < vector <int> > graph;
    vector <int> colored;
    vector <int> res1;

bool dfs(int start, int& finish) {
    if (start == finish) return true;
    //if (colored[start]) return false;
    colored[start] = true;
    for (unsigned int i = 0; i < graph[start].size(); i++) {
        int v = graph[start][i];
        if (!colored[v]) {
            bool res = dfs(v, finish);
            if (res) return true;
        }
    }
    /*cout << start << " " << graph[start].size() << ": ";
    for (int i = 0; i < graph[start].size(); i++) {
        cout << graph[start][i] << " ";
    }
    cout << endl << endl;*/
    return false;
}

void colored_clear() {
    int n = colored.size();
    for(int i = 0; i < n; i++) {
        colored[i] = 0;
    }
}

void bfs (int start, int& finish) {
    if (start == finish) return;
    colored[start] = true;
    for (unsigned int i = 0; i < graph[start].size(); i++) {
        int v = graph[start][i];
        if (!colored[v]) {
            bfs(v, finish);
        }
    }
}

int main() {
    FILE* in;
    //FILE* out;
    in = fopen("race.in", "r");
    int maxx = 0;
    //out = fopen("race.out", "w");
    ofstream out;
    out.open("race.out");
    vector <int> vertex;
    while(true) {
        char c = getc(in);
        if (c == EOF) {
            graph.push_back(vertex);
            vertex.clear();
            break;
        }
        if (c == '\n') {
            graph.push_back(vertex);
            vertex.clear();
        }
        if (isspace(c)) {
            continue;
        }
        ungetc(c, in);
        int n;
        fscanf(in, "%d", &n);
        maxx = max(n, maxx);
        vertex.push_back(n-1);
        //cout << n << endl;
    }

    int N = graph.size();
    if (graph[N-1].empty() && maxx < N) {
        graph.pop_back();
        N--;
    }
    /*for (int i = 0; i < N; i++) {
        cout << i << ": ";
        for (int j = 0; j < graph[i].size(); j++) {
            cout << graph[i][j] << " ";
        }
        cout << endl;
    }*/
    int start = 0, finish = 0;
    bool isstart[N];
    colored.resize(N);
    for (int i = 0; i < N; i++) {
        isstart[N] = true;
        colored[i] = false;
    }

    for (int i = 0; i < N; i++) {
        if (graph[i].empty()) {
            finish = i;
        }
        for (unsigned int j = 0; j < graph[i].size(); j++) {
            isstart[graph[i][j]] = false;
        }
    }

    for (int i = 0; i < N; i++) {
        if (isstart[i]) {
            start = i;
            break;
        }
    }

    //fprintf(out, "%d %d\n", (start+1), (finish+1));
    out << start+1 << " " << finish+1 << endl;

    vector <int> mandatory;
    vector <int> dummy;
    for (int i = 0; i < N; i++) {
        if (i == start) continue;
        if (i == finish) continue;
        swap(graph[i], dummy);
        bool res = dfs(start, finish);
        if (!res) {
            mandatory.push_back(i);
        }
        swap(dummy, graph[i]);
        colored_clear();
    }

    int m = mandatory.size();
    //fprintf(in, "%d ", m);
    out << m;
    for (int i = 0; i < m; i++) {
        //fprintf(in, " %d", mandatory[i]+1);
        out << " " << mandatory[i]+1;
    }
    //fprintf(in, "\n");
    out << endl;

    vector <int> divisors;
    res1.resize(N);
    for (int i = 0; i < N; i++) {
        res1[i] = false;
    }
    for (int x = 0; x < m; x++) {
        int v = mandatory[x];
        bfs(start, v);
        for (int i = 0; i < N; i++) {
            res1[i] = colored[i];
        }
        colored_clear();
        bfs (v, finish);
        bool nointersect = true;
        for (int i = 0; i < N; i++) {
            if (i == v) continue;
            if (colored[i] && res1[i]) {
                nointersect = false;
                break;
            }
        }
        if (nointersect) {
            divisors.push_back(v);
        }
        colored_clear();
    }

    int d = divisors.size();
    //fprintf(in, "%d ", d);
    out << d;
    for (int i = 0; i < d; i++) {
        //fprintf(in, " %d", divisors[i]+1);
        out << " " << divisors[i]+1;
    }
    //fprintf(in, "\n");
    out << endl;
    return 0;
}
